# Ops 的轉職之路 - Puppet 從入門就放棄

在這個 DevOps 文化如此蓬勃的時代裡，Ops 不再是單純 Ops，Dev 也不純了，每個工程師都要有能打十個的能力才能努力活下來，在大環境如此凶險的情況下，要如何讓自己擁有相同的生活品質早點下班，絕對是每個工程師夢寐以求的議題。

Puppet 是一個基於實現 infrastructure as a code 的組態管理工具，與其相同性質的有 Ansible、SaltStack、Chef 等工具，在國際擁有 Startup 到財星 Top 100 間佔有 75% 使用率。

- [Github：Ops 的轉職之路 - Puppet 從入門就放棄][github]
- [Gitbook：Puppet 從入門就放棄][gitbook]


# 目錄

- [Day 1 - 前言](docs/01.intro.md)
- [Day 2 - Puppet 是什麼？能吃嗎？](docs/02.what-puppet.md)
- [Day 3 - Puppet 的架構](docs/03.puppet-architecture.md)
- [Day 4 - 你不能不知道的 Puppet 小常識](docs/04.puppet-knowhow.md)
- [Day 5 - Master-Agent 架構 - Master 安裝](docs/05.puppet-master-install.md)
- [Day 6 - Master-Agent 架構 - Agent 安裝](docs/06.puppet-agent-install.md)
- [Day 7 - Master 和 Agent 之間的關係](docs/07.how-to-master-and-agent-auth.md)
- [Day 8 - 手把手系列 - 第一個 manifests](docs/08.how-to-write-manifests.md)
- [Day 9 - 手把手系列 - 第一個 module](docs/09.how-to-write-module.md)
- [Day 10 - modules 的篩選](docs/10.filter-module.md)
- [Day 11 - 處理 Resource 之間的順序](docs/11.resource-older.md)
- [Day 12 - 手把手系列 - 常用的 Resource](docs/12.simple-resource.md)
- [Day 13 - 用 Hiera 來處理資料](docs/13.how-to-use-hiera-data.md)
- [Day 14 - 用 eyaml-hiera 來處理機敏資料](docs/14.how-to-encrypt-hiera-data.md)
- [Day 15 - Puppet 內建的檔案系統](docs/15.puppet-file-system.md)
- [Day 16 - 手把手系列 - 用 templates 來處理檔案內容](docs/16.how-to-use-templates.md)
- [Day 17 - 什麼軟體盤點？就用 facter 就好啦！](docs/17.how-to-use-facter.md)
- [Day 18 - 手把手系列 - Linux 實戰](docs/18.lab-linux.md)
- [Day 19 - 手把手系列 - LAMP 實戰](docs/19.lab-lamp.md)
- [Day 20 - 手把手系列 - Nginx + NodeJS 實戰](docs/20.lab-nginx-nodejs.md)
- [Day 21 - 和很潮的工具結合 - Docker](docs/21.puppet-with-docker.md)
- [Day 22 - 和很潮的工具結合 - Packer](docs/22.puppet-with-packer.md)
- [Day 23 - 和很潮的工具結合 - Vagrant](docs/23.puppet-with-vagrant.md)
- [Day 24 - 設計基於 cronjob 的分散式概念](docs/24.puppet-des)
- [Day 25 - 設計 Role and Profile 架構的 Puppet](docs/25.role-and-profile.md)
- [Day 26 - 讓 Puppet 進版控吧！](docs/26.puppet-with-git.md)
- [Day 27 - Puppet 的測試工具](docs/27.puppet-test-tools.md)
- [Day 28 - 備份與還原](docs/28.puppet-backup.md)
- [Day 29 - 疑難雜症 Q&A](docs/29.puppet-qa.md)
- [Day 30 - 總結](docs/30.the-end.md)

## 致謝

非常感謝團長 [Miles](https://github.com/MilesChou) 的邀請，以及隊員 [聖佑](https://github.com/shengyou) 的互相努力，在這互相傷害的 30 天同甘共苦。

[github]: https://github.com/shazi7804/ops-puppet-30-days
[gitbook]: https://www.gitbook.com/book/shazi7804/puppet-manage-guide/details



